/*
 * Copyright (c) 2005, John Mettraux, OpenWFE.org
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * . Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.  
 * 
 * . Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * 
 * . Neither the name of the "OpenWFE" nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: AbstractAgent.java 3145 2006-08-31 03:21:38Z jmettraux $
 */

//
// AbstractAgent.java
//
// jmettraux@openwfe.org
//
// generated with 
// jtmpl 1.0.04 31.10.2002 John Mettraux (jmettraux@openwfe.org)
//

package openwfe.org.apre;

import openwfe.org.ApplicationContext;
import openwfe.org.engine.workitem.InFlowWorkItem;
import openwfe.org.engine.workitem.StringAttribute;
import openwfe.org.engine.workitem.IntegerAttribute;


/**
 * The beginning of an Agent implementation
 *
 * <p><font size=2>CVS Info :
 * <br>$Author: jmettraux $
 * <br>$Date: 2006-08-31 05:21:38 +0200 (Thu, 31 Aug 2006) $
 * <br>$Id: AbstractAgent.java 3145 2006-08-31 03:21:38Z jmettraux $ </font>
 *
 * @author jmettraux@openwfe.org
 */
public abstract class AbstractAgent

    implements Agent

{

    //
    // FIELDS

    protected org.apache.log4j.Logger log = org.apache.log4j.Logger
        .getLogger(this.getClass().getName());

    protected String name = null;
    protected ApplicationContext applicationContext = null;
    protected java.util.Map params = null;

    //
    // CONSTRUCTORS

    public void init 
        (final String agentName,
         final ApplicationContext context, 
         final java.util.Map agentParams)
    throws 
        ApreException
    {
        this.name = agentName;
        this.applicationContext = context;
        this.params = agentParams;
    }

    //
    // METHODS

    public String getName () { return this.name; }
    public ApplicationContext getApplicationContext () { return this.applicationContext; }
    public java.util.Map getParams () { return this.params; }

    public org.apache.log4j.Logger getLogger () { return this.log; }

    //
    // METHODS from Agent

    public void setAgentResult (final InFlowWorkItem wi, final int returnCode)
    {
        wi.getAttributes().put
            (new StringAttribute(AGENT_RESULT), 
             new IntegerAttribute(returnCode));
    }

}
